```@meta
CurrentModule = GridapSolvers
```

# GridapSolvers

Documentation for [GridapSolvers](https://github.com/gridap/GridapSolvers.jl).

GridapSolvers provides algebraic and non-algebraic solvers for the Gridap ecosystem, designed with High Performance Computing (HPC) in mind.

Solvers follow a modular design, where most blocks can be combined to produce PDE-taylored solvers for a wide range of problems.

```@contents
Pages = [
  "SolverInterfaces.md",
  "MultilevelTools.md",
  "LinearSolvers.md",
  "NonlinearSolvers.md",
  "BlockSolvers.md",
  "PatchBasedSmoothers.md"
  ]
```
